Sync with 2.34.8
[git/debian.git] / ci / lib.sh
blob5e01a927f105b450412c346590cf07eaa4f07578
1 # Library of functions shared by all CI scripts
3 skip_branch_tip_with_tag () {
4 # Sometimes, a branch is pushed at the same time the tag that points
5 # at the same commit as the tip of the branch is pushed, and building
6 # both at the same time is a waste.
8 # When the build is triggered by a push to a tag, $CI_BRANCH will
9 # have that tagname, e.g. v2.14.0. Let's see if $CI_BRANCH is
10 # exactly at a tag, and if so, if it is different from $CI_BRANCH.
11 # That way, we can tell if we are building the tip of a branch that
12 # is tagged and we can skip the build because we won't be skipping a
13 # build of a tag.
15 if TAG=$(git describe --exact-match "$CI_BRANCH" 2>/dev/null) &&
16 test "$TAG" != "$CI_BRANCH"
17 then
18 echo "$(tput setaf 2)Tip of $CI_BRANCH is exactly at $TAG$(tput sgr0)"
19 exit 0
23 # Save some info about the current commit's tree, so we can skip the build
24 # job if we encounter the same tree again and can provide a useful info
25 # message.
26 save_good_tree () {
27 echo "$(git rev-parse $CI_COMMIT^{tree}) $CI_COMMIT $CI_JOB_NUMBER $CI_JOB_ID" >>"$good_trees_file"
28 # limit the file size
29 tail -1000 "$good_trees_file" >"$good_trees_file".tmp
30 mv "$good_trees_file".tmp "$good_trees_file"
33 # Skip the build job if the same tree has already been built and tested
34 # successfully before (e.g. because the branch got rebased, changing only
35 # the commit messages).
36 skip_good_tree () {
37 if test true = "$GITHUB_ACTIONS"
38 then
39 return
42 if ! good_tree_info="$(grep "^$(git rev-parse $CI_COMMIT^{tree}) " "$good_trees_file")"
43 then
44 # Haven't seen this tree yet, or no cached good trees file yet.
45 # Continue the build job.
46 return
49 echo "$good_tree_info" | {
50 read tree prev_good_commit prev_good_job_number prev_good_job_id
52 if test "$CI_JOB_ID" = "$prev_good_job_id"
53 then
54 cat <<-EOF
55 $(tput setaf 2)Skipping build job for commit $CI_COMMIT.$(tput sgr0)
56 This commit has already been built and tested successfully by this build job.
57 To force a re-build delete the branch's cache and then hit 'Restart job'.
58 EOF
59 else
60 cat <<-EOF
61 $(tput setaf 2)Skipping build job for commit $CI_COMMIT.$(tput sgr0)
62 This commit's tree has already been built and tested successfully in build job $prev_good_job_number for commit $prev_good_commit.
63 The log of that build job is available at $SYSTEM_TASKDEFINITIONSURI$SYSTEM_TEAMPROJECT/_build/results?buildId=$prev_good_job_id
64 To force a re-build delete the branch's cache and then hit 'Restart job'.
65 EOF
69 exit 0
72 check_unignored_build_artifacts ()
74 ! git ls-files --other --exclude-standard --error-unmatch \
75 -- ':/*' 2>/dev/null ||
77 echo "$(tput setaf 1)error: found unignored build artifacts$(tput sgr0)"
78 false
82 # GitHub Action doesn't set TERM, which is required by tput
83 export TERM=${TERM:-dumb}
85 # Clear MAKEFLAGS that may come from the outside world.
86 export MAKEFLAGS=
88 # Set 'exit on error' for all CI scripts to let the caller know that
89 # something went wrong.
90 # Set tracing executed commands, primarily setting environment variables
91 # and installing dependencies.
92 set -ex
94 if test -n "$SYSTEM_COLLECTIONURI" || test -n "$SYSTEM_TASKDEFINITIONSURI"
95 then
96 CI_TYPE=azure-pipelines
97 # We are running in Azure Pipelines
98 CI_BRANCH="$BUILD_SOURCEBRANCH"
99 CI_COMMIT="$BUILD_SOURCEVERSION"
100 CI_JOB_ID="$BUILD_BUILDID"
101 CI_JOB_NUMBER="$BUILD_BUILDNUMBER"
102 CI_OS_NAME="$(echo "$AGENT_OS" | tr A-Z a-z)"
103 test darwin != "$CI_OS_NAME" || CI_OS_NAME=osx
104 CI_REPO_SLUG="$(expr "$BUILD_REPOSITORY_URI" : '.*/\([^/]*/[^/]*\)$')"
105 CC="${CC:-gcc}"
107 # use a subdirectory of the cache dir (because the file share is shared
108 # among *all* phases)
109 cache_dir="$HOME/test-cache/$SYSTEM_PHASENAME"
111 export GIT_PROVE_OPTS="--timer --jobs 10 --state=failed,slow,save"
112 export GIT_TEST_OPTS="--verbose-log -x --write-junit-xml"
113 MAKEFLAGS="$MAKEFLAGS --jobs=10"
114 test windows_nt != "$CI_OS_NAME" ||
115 GIT_TEST_OPTS="--no-chain-lint --no-bin-wrappers $GIT_TEST_OPTS"
116 elif test true = "$GITHUB_ACTIONS"
117 then
118 CI_TYPE=github-actions
119 CI_BRANCH="$GITHUB_REF"
120 CI_COMMIT="$GITHUB_SHA"
121 CI_OS_NAME="$(echo "$RUNNER_OS" | tr A-Z a-z)"
122 test macos != "$CI_OS_NAME" || CI_OS_NAME=osx
123 CI_REPO_SLUG="$GITHUB_REPOSITORY"
124 CI_JOB_ID="$GITHUB_RUN_ID"
125 CC="${CC:-gcc}"
126 DONT_SKIP_TAGS=t
128 cache_dir="$HOME/none"
130 export GIT_PROVE_OPTS="--timer --jobs 10"
131 export GIT_TEST_OPTS="--verbose-log -x"
132 MAKEFLAGS="$MAKEFLAGS --jobs=10"
133 test windows != "$CI_OS_NAME" ||
134 GIT_TEST_OPTS="--no-chain-lint --no-bin-wrappers $GIT_TEST_OPTS"
135 else
136 echo "Could not identify CI type" >&2
137 env >&2
138 exit 1
141 good_trees_file="$cache_dir/good-trees"
143 mkdir -p "$cache_dir"
145 test -n "${DONT_SKIP_TAGS-}" ||
146 skip_branch_tip_with_tag
147 skip_good_tree
149 if test -z "$jobname"
150 then
151 jobname="$CI_OS_NAME-$CC"
154 export DEVELOPER=1
155 export DEFAULT_TEST_TARGET=prove
156 export GIT_TEST_CLONE_2GB=true
157 export SKIP_DASHED_BUILT_INS=YesPlease
159 case "$runs_on_pool" in
160 ubuntu-*)
161 if test "$jobname" = "linux-gcc-default"
162 then
163 break
166 PYTHON_PACKAGE=python2
167 if [ "$jobname" = linux-gcc ]
168 then
169 PYTHON_PACKAGE=python3
171 MAKEFLAGS="$MAKEFLAGS PYTHON_PATH=/usr/bin/$PYTHON_PACKAGE"
173 export GIT_TEST_HTTPD=true
175 # The Linux build installs the defined dependency versions below.
176 # The OS X build installs much more recent versions, whichever
177 # were recorded in the Homebrew database upon creating the OS X
178 # image.
179 # Keep that in mind when you encounter a broken OS X build!
180 export LINUX_GIT_LFS_VERSION="1.5.2"
182 P4_PATH="$HOME/custom/p4"
183 GIT_LFS_PATH="$HOME/custom/git-lfs"
184 export PATH="$GIT_LFS_PATH:$P4_PATH:$PATH"
186 macos-latest)
187 if [ "$jobname" = osx-gcc ]
188 then
189 MAKEFLAGS="$MAKEFLAGS PYTHON_PATH=$(which python3)"
190 else
191 MAKEFLAGS="$MAKEFLAGS PYTHON_PATH=$(which python2)"
194 esac
196 case "$jobname" in
197 linux32)
198 CC=gcc
199 MAKEFLAGS="$MAKEFLAGS NO_UNCOMPRESS2=1"
201 linux-musl)
202 CC=gcc
203 MAKEFLAGS="$MAKEFLAGS PYTHON_PATH=/usr/bin/python3 USE_LIBPCRE2=Yes"
204 MAKEFLAGS="$MAKEFLAGS NO_REGEX=Yes ICONV_OMITS_BOM=Yes"
205 MAKEFLAGS="$MAKEFLAGS GIT_TEST_UTF8_LOCALE=C.UTF-8"
207 linux-leaks)
208 export SANITIZE=leak
209 export GIT_TEST_PASSING_SANITIZE_LEAK=true
211 esac
213 MAKEFLAGS="$MAKEFLAGS CC=${CC:-cc}"